<template>
  <v-dialog v-model="valueModel" max-width="500px">
    <v-card>
      <v-card-title>
        <span class="text-h5"
          >{{ isEdit ? 'Editar' : 'Novo' }} Funcionário</span
        >
      </v-card-title>

      <v-card-text>
        <v-container>
          <v-row>
            <v-col cols="12">
              <v-text-field v-model="form.name" label="Nome" />
            </v-col>
            <v-col cols="12">
              <v-text-field v-model="form.last_name" label="Sobrenome" />
            </v-col>
            <v-col cols="12" class="d-flex justify-center">
              <v-color-picker
                v-model="color"
                dot-size="25"
                swatches-max-height="200"
                @input="form.color = $event.hex"
              />
            </v-col>
          </v-row>
        </v-container>
      </v-card-text>

      <v-card-actions>
        <v-spacer />
        <v-btn color="blue darken-1" text @click="close">Cancelar</v-btn>
        <v-btn color="blue darken-1" text @click="save">OK</v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script>
export default {
  props: {
    item: {
      type: Object,
      default: null,
    },

    // v-model
    value: Boolean,
  },

  data() {
    return {
      form: {
        name: '',
        last_name: '',
        color: '',
      },

      color: {
        type: 'hex',
        hex: '#fff',
      },
    }
  },

  created() {
    this.changeLoadData(this.item)
  },

  methods: {
    changeLoadData(item) {
      if (this.isEdit) {
        this.form = Object.assign({}, item)
        this.color.hex = item.color
      }
    },

    close() {
      this.form = {
        name: '',
        last_name: '',
        color: '',
      }

      this.valueModel = false
    },

    save() {
      this.$emit(this.isEdit ? 'edit-form' : 'new-form', this.form)
    },
  },

  computed: {
    isEdit() {
      return this.item && Object.keys(this.item).length > 0
    },

    valueModel: {
      get() {
        return this.value
      },
      set(value) {
        this.$emit('input', value)
      },
    },
  },

  watch: {
    item: {
      handler: 'changeLoadData',
    },

    valueModel(bool) {
      if (bool) {
        this.changeLoadData(this.item)
      } else {
        this.close()
      }
    },
  },
}
</script>
